diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet-apps/model/dhcp-header.cc ns-3.39/src/internet-apps/model/dhcp-header.cc
--- ns-3.38/src/internet-apps/model/dhcp-header.cc	2023-03-16 20:54:23.608868600 -0700
+++ ns-3.39/src/internet-apps/model/dhcp-header.cc	2023-07-05 14:23:47.829427500 -0700
@@ -75,7 +75,7 @@
 void
 DhcpHeader::SetType(uint8_t type)
 {
-    if (m_opt[OP_MSGTYPE] == false)
+    if (!m_opt[OP_MSGTYPE])
     {
         m_len += 3;
         m_opt[OP_MSGTYPE] = true;
@@ -154,7 +154,7 @@
 void
 DhcpHeader::SetDhcps(Ipv4Address addr)
 {
-    if (m_opt[OP_SERVID] == false)
+    if (!m_opt[OP_SERVID])
     {
         m_len += 6;
         m_opt[OP_SERVID] = true;
@@ -171,7 +171,7 @@
 void
 DhcpHeader::SetReq(Ipv4Address addr)
 {
-    if (m_opt[OP_ADDREQ] == false)
+    if (!m_opt[OP_ADDREQ])
     {
         m_len += 6;
         m_opt[OP_ADDREQ] = true;
@@ -188,7 +188,7 @@
 void
 DhcpHeader::SetMask(uint32_t addr)
 {
-    if (m_opt[OP_MASK] == false)
+    if (!m_opt[OP_MASK])
     {
         m_len += 6;
         m_opt[OP_MASK] = true;
@@ -205,7 +205,7 @@
 void
 DhcpHeader::SetRouter(Ipv4Address addr)
 {
-    if (m_opt[OP_ROUTE] == false)
+    if (!m_opt[OP_ROUTE])
     {
         m_len += 6;
         m_opt[OP_ROUTE] = true;
@@ -222,7 +222,7 @@
 void
 DhcpHeader::SetLease(uint32_t time)
 {
-    if (m_opt[OP_LEASE] == false)
+    if (!m_opt[OP_LEASE])
     {
         m_len += 6;
         m_opt[OP_LEASE] = true;
@@ -239,7 +239,7 @@
 void
 DhcpHeader::SetRenew(uint32_t time)
 {
-    if (m_opt[OP_RENEW] == false)
+    if (!m_opt[OP_RENEW])
     {
         m_len += 6;
         m_opt[OP_RENEW] = true;
@@ -256,7 +256,7 @@
 void
 DhcpHeader::SetRebind(uint32_t time)
 {
-    if (m_opt[OP_REBIND] == false)
+    if (!m_opt[OP_REBIND])
     {
         m_len += 6;
         m_opt[OP_REBIND] = true;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet-apps/model/ping.h ns-3.39/src/internet-apps/model/ping.h
--- ns-3.38/src/internet-apps/model/ping.h	2023-03-16 20:54:23.608868600 -0700
+++ ns-3.39/src/internet-apps/model/ping.h	2023-07-05 14:23:47.829427500 -0700
@@ -145,7 +145,7 @@
      *
      * \param [in] report The report information
      */
-    typedef void (*ReportTrace)(const struct PingReport& report);
+    typedef void (*ReportTrace)(const PingReport& report);
 
   private:
     /**
@@ -222,7 +222,7 @@
     /// TracedCallback for drop events
     TracedCallback<uint16_t, DropReason> m_dropTrace;
     /// TracedCallback for final ping report
-    TracedCallback<const struct PingReport&> m_reportTrace;
+    TracedCallback<const PingReport&> m_reportTrace;
     /// Variable to stor verbose mode
     VerboseMode m_verbose{VerboseMode::VERBOSE};
     /// Received packets counter
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet-apps/model/radvd.cc ns-3.39/src/internet-apps/model/radvd.cc
--- ns-3.38/src/internet-apps/model/radvd.cc	2023-03-16 20:54:23.608868600 -0700
+++ ns-3.39/src/internet-apps/model/radvd.cc	2023-07-05 14:23:47.829427500 -0700
@@ -192,7 +192,7 @@
 {
     NS_LOG_FUNCTION(this << dst << reschedule);
 
-    if (reschedule == true)
+    if (reschedule)
     {
         config->SetLastRaTxTime(Simulator::Now());
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lr-wpan/examples/CMakeLists.txt ns-3.39/src/lr-wpan/examples/CMakeLists.txt
--- ns-3.38/src/lr-wpan/examples/CMakeLists.txt	2023-03-16 20:54:23.632868500 -0700
+++ ns-3.39/src/lr-wpan/examples/CMakeLists.txt	2023-07-05 14:23:47.869427400 -0700
@@ -5,6 +5,7 @@
     lr-wpan-phy-test
     lr-wpan-ed-scan
     lr-wpan-active-scan
+    lr-wpan-orphan-scan
 )
 
 foreach(
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lr-wpan/examples/lr-wpan-orphan-scan.cc ns-3.39/src/lr-wpan/examples/lr-wpan-orphan-scan.cc
--- ns-3.38/src/lr-wpan/examples/lr-wpan-orphan-scan.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/src/lr-wpan/examples/lr-wpan-orphan-scan.cc	2023-07-05 14:23:47.869427400 -0700
@@ -0,0 +1,215 @@
+/*
+ * Copyright (c) 2023 Tokushima University, Japan.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author:  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+/*
+ * [00:00:00:00:00:00:00:01 | 00:01]     [00:00:00:00:00:00:00:02 | ff:ff]
+ *  PAN Coordinator 1 (PAN: 5)                      End Device
+ *       |---------------------100m-----------------------|
+ *  Channel 12                                (Orphan Scan channels 11-14)
+ *
+ *
+ * This example demonstrate the usage of the MAC MLME-SCAN.request (ORPHAN scan) primitive as
+ * described by IEEE 802.15.4-2011 (See Figures 14 and 15).
+ *
+ * Orphan scan is used typically on devices as a result of repeated communication failures
+ * (For example, lossing too many ACK). An orphan scan represents the attempt of a device to
+ * relocate its coordinator. In some situations, it can be used by devices higher layers to not only
+ * rejoin a network but also join a network for the first time (Like in the joining through
+ * orphaning mechanism described in Zigbee networks).
+ *
+ * In this example, the end device is set to scan 4 channels (11~14) for a period of
+ * macResponseWaitTime until it finally gets in contact with the coordinator.
+ * On contact, the coordinator responds to the device (via coordinator realignment command)
+ * an assign it a short address. The detailed sequence of events is as following:
+ *
+ * 1) [Time 2s] The coordinator start a network in channel 12.
+ * 2) [Time 3s] The end device start orphan scan and transmits a orphan
+ *    notification cmd on channel 11.
+ * 3) No response is received in channel 11, therefore, the device ends scanning on
+ *    channel 11 after macResponseWaitTime and repeats step 2 in channel 12.
+ * 4) [Time 3.00269s] The orphan notification command is received by the coordinator in
+ *    channel 12. The coordinator verify the requesting device and replies to the device
+ *    with a coordinator realignment command containing the assigned short address [DE:AF].
+ * 5) [Time 3.00646s] The device receives the coordinator realignment command, update its
+ *    macPanId, macShortAddress, macCoordShortAddress and macCoordExtAddress.
+ * 6) Scanning of the remaining channels 13 and 14 is cancelled.
+ */
+
+#include <ns3/constant-position-mobility-model.h>
+#include <ns3/core-module.h>
+#include <ns3/log.h>
+#include <ns3/lr-wpan-module.h>
+#include <ns3/packet.h>
+#include <ns3/propagation-delay-model.h>
+#include <ns3/propagation-loss-model.h>
+#include <ns3/simulator.h>
+#include <ns3/single-model-spectrum-channel.h>
+
+#include <iostream>
+
+using namespace ns3;
+
+static void
+ScanConfirm(Ptr<LrWpanNetDevice> device, MlmeScanConfirmParams params)
+{
+    if (params.m_status == MLMESCAN_SUCCESS)
+    {
+        std::cout << Simulator::Now().As(Time::S) << " Node " << device->GetNode()->GetId() << " ["
+                  << device->GetMac()->GetShortAddress() << " | "
+                  << device->GetMac()->GetExtendedAddress()
+                  << "] MLME-SCAN.confirm: Active scan status SUCCESSFUL "
+                  << "(Coordinator found and address assigned) \n";
+    }
+    else if (params.m_status == MLMESCAN_NO_BEACON)
+    {
+        std::cout << Simulator::Now().As(Time::S) << " Node " << device->GetNode()->GetId() << " ["
+                  << device->GetMac()->GetShortAddress() << " | "
+                  << device->GetMac()->GetExtendedAddress()
+                  << "] MLME-SCAN.confirm: Could not locate coordinator "
+                  << "(Coord realignment command not received) "
+                  << "status: " << params.m_status << "\n";
+    }
+    else
+    {
+        std::cout << Simulator::Now().As(Time::S) << " Node " << device->GetNode()->GetId() << " ["
+                  << device->GetMac()->GetShortAddress() << " | "
+                  << device->GetMac()->GetExtendedAddress()
+                  << "] MLME-SCAN.confirm: An error occurred during scanning, "
+                  << "status: " << params.m_status << "\n";
+    }
+}
+
+static void
+OrphanIndication(Ptr<LrWpanNetDevice> device, MlmeOrphanIndicationParams params)
+{
+    // The steps taken by the coordinator on the event of an orphan indication
+    // are meant to be implemented by the next higher layer and are out of the scope of the
+    // standard. In this example, we simply accept the request , assign a fixed short address
+    // [DE:AF] and respond to the requesting device using a MLME-ORPHAN.response.
+
+    std::cout << Simulator::Now().As(Time::S) << " Node " << device->GetNode()->GetId() << " ["
+              << device->GetMac()->GetShortAddress() << " | "
+              << device->GetMac()->GetExtendedAddress()
+              << "] MLME-ORPHAN.indication: Orphan Notification received, processing...\n";
+
+    MlmeOrphanResponseParams respParams;
+    respParams.m_assocMember = true;
+    respParams.m_orphanAddr = params.m_orphanAddr;
+    respParams.m_shortAddr = Mac16Address("DE:AF");
+
+    Simulator::ScheduleNow(&LrWpanMac::MlmeOrphanResponse, device->GetMac(), respParams);
+}
+
+int
+main(int argc, char* argv[])
+{
+    LogComponentEnableAll(LogLevel(LOG_PREFIX_TIME | LOG_PREFIX_FUNC));
+
+    // Create 2 PAN coordinator nodes, and 1 end device
+    Ptr<Node> coord1 = CreateObject<Node>();
+    Ptr<Node> endNode = CreateObject<Node>();
+
+    Ptr<LrWpanNetDevice> coord1NetDevice = CreateObject<LrWpanNetDevice>();
+    Ptr<LrWpanNetDevice> endNodeNetDevice = CreateObject<LrWpanNetDevice>();
+
+    // PAN Coordinators configurations require to set both, the EUI-64 (extended address)
+    // and to assign their own short address.
+    coord1NetDevice->GetMac()->SetExtendedAddress(Mac64Address("00:00:00:00:00:00:00:01"));
+    coord1NetDevice->GetMac()->SetShortAddress(Mac16Address("00:01"));
+
+    // Other devices must have only its EUI-64 and later on, their short address is
+    // potentially assigned by the coordinator.
+    endNodeNetDevice->GetMac()->SetExtendedAddress(Mac64Address("00:00:00:00:00:00:00:02"));
+
+    // Configure Spectrum channel
+    Ptr<SingleModelSpectrumChannel> channel = CreateObject<SingleModelSpectrumChannel>();
+    Ptr<LogDistancePropagationLossModel> propModel =
+        CreateObject<LogDistancePropagationLossModel>();
+    Ptr<ConstantSpeedPropagationDelayModel> delayModel =
+        CreateObject<ConstantSpeedPropagationDelayModel>();
+    channel->AddPropagationLossModel(propModel);
+    channel->SetPropagationDelayModel(delayModel);
+
+    coord1NetDevice->SetChannel(channel);
+    endNodeNetDevice->SetChannel(channel);
+
+    coord1->AddDevice(coord1NetDevice);
+    endNode->AddDevice(endNodeNetDevice);
+
+    // Mobility
+    Ptr<ConstantPositionMobilityModel> coord1Mobility =
+        CreateObject<ConstantPositionMobilityModel>();
+    coord1Mobility->SetPosition(Vector(0, 0, 0));
+    coord1NetDevice->GetPhy()->SetMobility(coord1Mobility);
+
+    Ptr<ConstantPositionMobilityModel> endNodeMobility =
+        CreateObject<ConstantPositionMobilityModel>();
+    endNodeMobility->SetPosition(Vector(100, 0, 0));
+    endNodeNetDevice->GetPhy()->SetMobility(endNodeMobility);
+
+    // MAC layer Callbacks hooks
+    endNodeNetDevice->GetMac()->SetMlmeScanConfirmCallback(
+        MakeBoundCallback(&ScanConfirm, endNodeNetDevice));
+
+    coord1NetDevice->GetMac()->SetMlmeOrphanIndicationCallback(
+        MakeBoundCallback(&OrphanIndication, coord1NetDevice));
+
+    /////////////////
+    // ORPHAN SCAN //
+    /////////////////
+
+    // PAN coordinator N0 (PAN 5) is set to channel 12 in non-beacon mode
+    // but answer to beacon request and orphan notification commands.
+    MlmeStartRequestParams params;
+    params.m_panCoor = true;
+    params.m_PanId = 5;
+    params.m_bcnOrd = 15;
+    params.m_sfrmOrd = 15;
+    params.m_logCh = 12;
+    Simulator::ScheduleWithContext(1,
+                                   Seconds(2.0),
+                                   &LrWpanMac::MlmeStartRequest,
+                                   coord1NetDevice->GetMac(),
+                                   params);
+
+    // End device N1 is set to scan 4 channels looking for the presence of a coordinator.
+    // On each channel, a single orphan notification command is sent and a response is
+    // waited for a maximum time of macResponseWaitTime. If a reply is received from a
+    // coordinator within this time (coordinator realignment command), the programmed scans on
+    // other channels is suspended.
+    // Scan Channels are represented by bits 0-26  (27 LSB)
+    //                       ch 14  ch 11
+    //                           |  |
+    // 0x7800  = 0000000000000000111100000000000
+    MlmeScanRequestParams scanParams;
+    scanParams.m_chPage = 0;
+    scanParams.m_scanChannels = 0x7800;
+    scanParams.m_scanType = MLMESCAN_ORPHAN;
+    Simulator::ScheduleWithContext(1,
+                                   Seconds(3.0),
+                                   &LrWpanMac::MlmeScanRequest,
+                                   endNodeNetDevice->GetMac(),
+                                   scanParams);
+
+    Simulator::Stop(Seconds(2000));
+    Simulator::Run();
+
+    Simulator::Destroy();
+    return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lr-wpan/examples/lr-wpan-per-plot.cc ns-3.39/src/lr-wpan/examples/lr-wpan-per-plot.cc
--- ns-3.38/src/lr-wpan/examples/lr-wpan-per-plot.cc	2023-03-16 20:54:23.632868500 -0700
+++ ns-3.39/src/lr-wpan/examples/lr-wpan-per-plot.cc	2023-07-05 14:23:47.869427400 -0700
@@ -86,7 +86,7 @@
 
     Gnuplot perplot = Gnuplot("802.15.4-per-vs-rxSignal.eps");
     Gnuplot2dDataset perdatasetExperimental("Experimental");
-    Gnuplot2dDataset perdatasetTheorical("Theoretical");
+    Gnuplot2dDataset perdatasetTheoretical("Theoretical");
 
     Ptr<Node> n0 = CreateObject<Node>();
     Ptr<Node> n1 = CreateObject<Node>();
@@ -214,7 +214,7 @@
             sensThreshold = false;
         }
 
-        perdatasetTheorical.Add(j, perTheoretical);
+        perdatasetTheoretical.Add(j, perTheoretical);
     }
 
     std::cout << "_____________________________________________________________________________\n";
@@ -229,7 +229,7 @@
        << "Rx Sensitivity (Theo) = " << sensitivityTheo << " dBm";
 
     perplot.AddDataset(perdatasetExperimental);
-    perplot.AddDataset(perdatasetTheorical);
+    perplot.AddDataset(perdatasetTheoretical);
 
     perplot.SetTitle(os.str());
     perplot.SetTerminal("postscript eps color enh \"Times-BoldItalic\"");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lr-wpan/helper/lr-wpan-helper.cc ns-3.39/src/lr-wpan/helper/lr-wpan-helper.cc
--- ns-3.38/src/lr-wpan/helper/lr-wpan-helper.cc	2023-03-16 20:54:23.632868500 -0700
+++ ns-3.39/src/lr-wpan/helper/lr-wpan-helper.cc	2023-07-05 14:23:47.869427400 -0700
@@ -361,7 +361,7 @@
     Ptr<PcapFileWrapper> file =
         pcapHelper.CreateFile(filename, std::ios::out, PcapHelper::DLT_IEEE802_15_4);
 
-    if (promiscuous == true)
+    if (promiscuous)
     {
         device->GetMac()->TraceConnectWithoutContext("PromiscSniffer",
                                                      MakeBoundCallback(&PcapSniffLrWpan, file));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lr-wpan/model/lr-wpan-constants.h ns-3.39/src/lr-wpan/model/lr-wpan-constants.h
--- ns-3.38/src/lr-wpan/model/lr-wpan-constants.h	2023-03-16 20:54:23.632868500 -0700
+++ ns-3.39/src/lr-wpan/model/lr-wpan-constants.h	2023-07-05 14:23:47.869427400 -0700
@@ -119,7 +119,7 @@
  * The maximum size, in octets, of a beacon payload.
  * See IEEE 802.15.4-2011, section 6.4.1, Table 51.
  */
-constexpr uint32_t aMaxBeaconPayloadLenght{aMaxPhyPacketSize - aMaxBeaconOverhead};
+constexpr uint32_t aMaxBeaconPayloadLength{aMaxPhyPacketSize - aMaxBeaconOverhead};
 
 /** @} */
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lr-wpan/model/lr-wpan-csmaca.cc ns-3.39/src/lr-wpan/model/lr-wpan-csmaca.cc
--- ns-3.38/src/lr-wpan/model/lr-wpan-csmaca.cc	2023-03-16 20:54:23.632868500 -0700
+++ ns-3.39/src/lr-wpan/model/lr-wpan-csmaca.cc	2023-07-05 14:23:47.869427400 -0700
@@ -31,7 +31,9 @@
 #include <algorithm>
 
 #undef NS_LOG_APPEND_CONTEXT
-#define NS_LOG_APPEND_CONTEXT std::clog << "[address " << m_mac->GetShortAddress() << "] ";
+#define NS_LOG_APPEND_CONTEXT                                                                      \
+    std::clog << "[address " << m_mac->GetShortAddress() << " | " << m_mac->GetExtendedAddress()   \
+              << "] ";
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lr-wpan/model/lr-wpan-fields.cc ns-3.39/src/lr-wpan/model/lr-wpan-fields.cc
--- ns-3.38/src/lr-wpan/model/lr-wpan-fields.cc	2023-03-16 20:54:23.632868500 -0700
+++ ns-3.39/src/lr-wpan/model/lr-wpan-fields.cc	2023-07-05 14:23:47.869427400 -0700
@@ -268,18 +268,18 @@
 
     if (m_gtsSpecDescCount > 0)
     {
-        uint8_t gtsDescStartAndLenght;
+        uint8_t gtsDescStartAndLength;
         i.WriteU8(GetGtsDirectionField());
 
         for (int j = 0; j < m_gtsSpecDescCount; j++)
         {
             WriteTo(i, m_gtsList[j].m_gtsDescDevShortAddr);
 
-            gtsDescStartAndLenght =
+            gtsDescStartAndLength =
                 (m_gtsList[j].m_gtsDescStartSlot & 0x0F) | // GTS descriptor bits 16-19
                 (m_gtsList[j].m_gtsDescLength & 0xF0);     // GTS descriptor bits 20-23
 
-            i.WriteU8(gtsDescStartAndLenght);
+            i.WriteU8(gtsDescStartAndLength);
         }
     }
     return i;
@@ -296,14 +296,14 @@
         uint8_t gtsDirectionField = i.ReadU8();
         SetGtsDirectionField(gtsDirectionField);
 
-        uint8_t gtsDescStartAndLenght;
+        uint8_t gtsDescStartAndLength;
         for (int j = 0; j < m_gtsSpecDescCount; j++)
         {
             ReadFrom(i, m_gtsList[j].m_gtsDescDevShortAddr);
 
-            gtsDescStartAndLenght = i.ReadU8();
-            m_gtsList[j].m_gtsDescStartSlot = (gtsDescStartAndLenght) & (0x0F);
-            m_gtsList[j].m_gtsDescLength = (gtsDescStartAndLenght >> 4) & (0x0F);
+            gtsDescStartAndLength = i.ReadU8();
+            m_gtsList[j].m_gtsDescStartSlot = (gtsDescStartAndLength) & (0x0F);
+            m_gtsList[j].m_gtsDescLength = (gtsDescStartAndLength >> 4) & (0x0F);
         }
     }
     return i;
